package bank;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import org.jboss.aop.joinpoint.Invocation;

public class SecurityAspect
{
   Map<String, String> usernamePassword = new HashMap<String, String>();
   Map<String, List<String>> userRoles = new HashMap<String, List<String>>();
   
   public SecurityAspect() throws FileNotFoundException, IOException, URISyntaxException
   {
      URL url = this.getClass().getResource("/security.properties");
      Properties properties = new Properties();
      properties.load(new FileInputStream(new File(url.toURI())));
      
      for (Enumeration en = properties.propertyNames(); en.hasMoreElements() ; )
      {
         String username = (String)en.nextElement();
         String value = properties.getProperty(username);
         
         //Before the ; is the password
         List<String> roles = null;
         String pwd = value;
         int i = value.indexOf(";");
         if (i >= 0)
         {
            pwd = pwd.substring(0, i);
            
            if(value.length() - 1 > i)
            {
               String rolesString = value.substring(i + 1);
               roles = Arrays.asList(rolesString.split(","));
               userRoles.put(username, roles);
            }
         }
         usernamePassword.put(username, pwd);
      }
   }
   
   public Object checkSecurity(Invocation invocation) throws Throwable
   {
      String username = LoginInfo.getUsername();
      String password = usernamePassword.get(username);
      if (password == null)
      {
         throw new SecurityException("Unknown user");
      }
      if (!password.equals(LoginInfo.getPassword()))
      {
         throw new SecurityException("Wrong password");
      }
      Roles rolesAnnotaton = (Roles)invocation.resolveAnnotation(Roles.class);
      List<String> hasRoles = userRoles.get(username);
      boolean hasRole = false;
      if (hasRoles != null)
      {
         for (String role : rolesAnnotaton.roles())
         {
            if (hasRoles.contains(role))
            {
               hasRole = true;
               break;
            }
         }
      }
      
      if (!hasRole)
      {
         throw new SecurityException("Wrong roles for user");
      }
      
      return invocation.invokeNext();
   }
}
